
variables:
  IMG_JDK_GRADLE: gradle:8.2.0-jdk17-jammy
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  DEPLOY_DOCKER_CONTAINER_NAME: apigateway
  CI_GROUP_NAME: rentahouse1
  # CI_PROJECT_NAME: kilroywashere.devops
  CI_REGISTRY_IMAGE: $CI_REGISTRY/$CI_GROUP_NAME/$DEPLOY_DOCKER_CONTAINER_NAME
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA


stages:
  - clean
  - build
  - test
  - package

clean-job:
  stage: clean
  image: $IMG_JDK_GRADLE
  #tags: # gitlab-runner perso
  #    - docker-gradle
  script:
    - echo "Cleaning from previous builds"
    - gradle clean


package-files-job:
  stage: build
  script:
    # Obtention des fichiers sécurisés GitLab
    - mkdir -p ./app/files/
    - curl -s https://gitlab.com/gitlab-org/incubation-engineering/mobile-devops/load-secure-files/-/raw/main/installer | bash
    - cp -r .secure_files/* ./app/files/
    - echo "Juste pour vérifier"
    - ls -lah ./app/files/
  artifacts:
    untracked: true
    expire_in: 1 hour
    paths:
      - ./app/files/

build-job:
  stage: build
  image: $IMG_JDK_GRADLE
  #tags:
  #    - docker-gradle
  script:
    - gradle build
  artifacts:
    paths:
      - build/libs/*.jar

unit-test-job:
  image: $IMG_JDK_GRADLE
  #tags:
  #    - docker-gradle
  stage: test
  script:
    - echo "Running unit tests..."
    - gradle test


package-job:
  stage: package
  image: docker:stable
  services:
    - docker:stable-dind
  dependencies:
    - package-files-job
    - build-job
  script:
    # Copie des fichiers application*.yml
    - cp ./app/files/application*.yml ./src/main/resources/
    # package docker
    - docker build -f ./DockerfileGitlab -t $TAG_COMMIT -t $TAG_LATEST .
    - docker login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker push $TAG_COMMIT
    - docker push $TAG_LATEST